## gnulib 20180621~6979c25

=== debian/changelog ===
gnulib (20180621~6979c25-3) experimental; urgency=medium

  * QA upload.
  * vasnprintf: Fix heap memory overrun bug (CVE-2018-17942) (Closes: #910757)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 12 Feb 2019 07:14:48 +0100

gnulib (20180621~6979c25-2) experimental; urgency=medium

  * Update Vcs-* fields: Moved to collaborative debian maintenance.
  * Orphan package.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 10 Feb 2019 15:53:04 +0100

gnulib (20180621~6979c25-1) experimental; urgency=medium

  * Update debian/clscal/clscan to handle boilerplate LGPLv3+ or GPLv2.
  * Update copyright info: Tighten coverage.
  * Add TODO on getting clscan to handle multi-line copyright field.
  * Unfuzz patch 01. Refresh patch with shortening quilt options.
  * Update DEP-3 patch headers.
  * Add patch 03
    to avoid tests broken or depending on unavailable tool cppi.
  * Stop install documentation file NEWS.stable:
    Unavailable now that we use upstream source directly.
  * Stop install config.charset: No longer provided upstream.
  * Enable testing during build.
  * Update copyright file.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 01 Feb 2019 16:22:56 +0100

gnulib (20140202+stable-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * vasnprintf: Fix heap memory overrun bug (CVE-2018-17942) (Closes: #910757)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 09 Feb 2019 11:11:06 +0100

gnulib (20140202+stable-3) unstable; urgency=medium

  * Update copyright info:
    + Fix generate copyright file deterministically.
    + Add TODO about fixing license detection of multi-licensed files.
    + Fix use license exception notation.
    + Use semantic newlines in License fields.
    + Single-space indent License fields.
    + Update coverage.
    + Use https protocol in file format URL.
    + Update source URLs.
    + Add alternate URL for upstream contact.
    + Use SPDX license shortnames.
    + Update coverage.
  * Use https protocol in homepage URL.
  * Update package relations:
    + Wrap and sort entries.
    + Relax to build-depend unversioned on debhelper, stop explicitly
      build-depend on dpkg-dev, and relax to depend unversioned on
      gettext: Needed versions satisfied even in oldstable.
  * Add git-buildpackage config:
    + Enable pristine-tar.
    + Enable signed tags.
    + Filter out any .git* files.
  * Update Vcs-* fields: Source moved to Salsa.
  * Friendly packaging takeover, in team build-common.
    Closes: Bug#847043. Thanks for past work to Ian Beckwith.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 23 Jun 2018 09:23:11 +0200

=== debian/rules ===
#!/usr/bin/make -f

#EXPORT DH_VERBOSE=1

%:
	dh ${@}

override_dh_auto_clean:
	$(MAKE) -C doc clean
	-rm -rf debian/git-merge-changelog.src
	-rm -f debian/git-merge-changelog.1
	dh_auto_clean

override_dh_auto_configure-arch:
	./gnulib-tool --create-testdir --without-tests -S \
		--dir=debian/git-merge-changelog.src git-merge-changelog
	dh_auto_configure --sourcedir debian/git-merge-changelog.src

override_dh_auto_build-indep:
	$(MAKE) -C doc info
	$(MAKE) -C doc html

override_dh_auto_build-arch:
	dh_auto_build --sourcedir debian/git-merge-changelog.src
	pod2man --section=1 debian/git-merge-changelog.pod debian/git-merge-changelog.1

override_dh_auto_install-arch:
	dh_auto_install --sourcedir=debian/git-merge-changelog.src --destdir=debian/git-merge-changelog

override_dh_auto_install-indep:
	mkdir -p debian/gnulib/usr/bin
	cp -a check-module debian/gnulib/usr/bin
	mkdir -p debian/gnulib/usr/share/gnulib
	cp -a build-aux posix-modules config doc lib m4 modules top tests \
	      MODULES.html.sh Makefile gnulib-tool cfg.mk check-copyright \
	      debian/gnulib/usr/share/gnulib
	ln -s ../share/gnulib/gnulib-tool debian/gnulib/usr/bin
	# Fix permissions
	chmod 0755 debian/gnulib/usr/share/gnulib/build-aux/config.guess
	chmod 0755 debian/gnulib/usr/share/gnulib/build-aux/config.sub
	chmod 0755 debian/gnulib/usr/share/gnulib/build-aux/gendocs.sh
	chmod 0644 debian/gnulib/usr/share/gnulib/doc/gendocs_template
	chmod 0644 debian/gnulib/usr/share/gnulib/m4/fflush.m4
	chmod 0644 debian/gnulib/usr/share/gnulib/modules/canonicalize-lgpl
	chmod 0644 debian/gnulib/usr/share/gnulib/modules/fflush
	chmod 0644 debian/gnulib/usr/share/gnulib/modules/fflush-tests
	chmod 0644 debian/gnulib/usr/share/gnulib/tests/test-base64.c
	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-closein.sh
	chmod 0644 debian/gnulib/usr/share/gnulib/tests/test-fflush.c
	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-posix_spawn1.in.sh
	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-posix_spawn2.in.sh
	# Remove unused files
	rm -f debian/gnulib/usr/share/gnulib/doc/gnulib.info
	rm -f debian/gnulib/usr/share/gnulib/doc/gnulib.html
	rm -f debian/gnulib/usr/share/gnulib/modules/COPYING
	rm -f debian/gnulib/usr/share/gnulib/*/.cvsignore debian/gnulib/usr/share/gnulib/.cvsignore
	rm -f debian/gnulib/usr/share/gnulib/*/.gitignore debian/gnulib/usr/share/gnulib/.gitignore
	rm -f debian/gnulib/usr/share/gnulib/*/.gitattributes debian/gnulib/usr/share/gnulib/.gitattributes

## gnulib 20200105~a7903da

=== Makefile ===
# GNU Makefile for gnulib central.
# Copyright (C) 2006, 2009-2020 Free Software Foundation, Inc.
#
# Copying and distribution of this file, with or without modification,
# in any medium, are permitted without royalty provided the copyright
# notice and this notice are preserved.

# This Makefile requires the use of GNU make.  Some targets require
# that you have tools like git, makeinfo and cppi installed.

# Required for the use of <(...) below.
SHELL=bash

# Produce some files that are not stored in the repository.
all:

# Produce the documentation in readable form.
info html dvi pdf:
	cd doc && $(MAKE) $@ && $(MAKE) mostlyclean

# Collect the names of rules starting with 'sc_'.
syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p'\
			Makefile))

# Perform some platform independent checks on the gnulib code.
check: $(syntax-check-rules)

sc_prefer_ac_check_funcs_once:
	@if test -d .git; then						\
	  git grep -w -l AC_CHECK_FUNCS modules				\
	    && { echo use AC_CHECK_FUNCS_ONCE, not AC_CHECK_FUNCS	\
		   in modules/ 1>&2; exit 1; } || :			\
	else :; fi

sc_prohibit_leading_TABs:
	@if test -d .git; then						\
	  git grep -l '^ *	' lib m4 tests				\
	    | grep -Ev '^lib/reg|Makefile|test-update-copyright'	\
	    | grep .							\
	    && { printf '*** %s\n' 'indent with spaces, not TABs;'	\
		 1>&2; exit 1; } || :					\
	else :; fi

sc_prohibit_augmenting_PATH_via_TESTS_ENVIRONMENT:
	@if test -d .git; then						\
	  url=https://lists.gnu.org/r/bug-gnulib/2010-09/msg00064.html; \
	  git grep '^[	 ]*TESTS_ENVIRONMENT += PATH=' modules		\
	    && { printf '%s\n' 'Do not augment PATH via TESTS_ENVIRONMENT;' \
		 "  see <$$url>" 1>&2; exit 1; } || :			\
	else :; fi

# It's easy to forget the noise-suppressing "@" at the beginning
# of each sc_ rule.  Check for it both in maint.mk and in this file.
sc_prohibit_sc_omitted_at:
	@if test -d .git; then						\
	  git grep -n -A1 '^sc_[[:alnum:]_-]*:' top/maint.mk Makefile	\
            | grep -vE ':sc_|[0-9][-]	@|--$$'				\
            | sed 's/-\([0-9][0-9]*\)-/:\1:/'				\
	    | grep .							\
	    && { printf '*** %s\n' 'oops; missing "@"'			\
		 1>&2; exit 1; } || :					\
	else :; fi

# Run all maint.mk syntax-check tests on gnulib's sources.
sc_maint:
	@rm -f maint.mk; ln -s top/maint.mk maint.mk
	$(MAKE) -s srcdir=. gnulib_dir=. _build-aux=build-aux \
            -f cfg.mk -f maint.mk syntax-check
	rm -f maint.mk

# Files in m4/ that (exceptionally) may use AC_LIBOBJ.
# Do not include their ".m4" suffix.
allow_AC_LIBOBJ =	\
  close			\
  dprintf		\
  dup2			\
  faccessat		\
  fchdir		\
  fclose		\
  fcntl			\
  fprintf-posix		\
  open			\
  printf-posix-rpl	\
  snprintf		\
  sprintf-posix		\
  stdio_h		\
  vasnprintf		\
  vasprintf		\
  vdprintf		\
  vfprintf-posix	\
  vprintf-posix		\
  vsnprintf		\
  vsprintf-posix

allow_AC_LIBOBJ_or := $(shell echo $(allow_AC_LIBOBJ) | tr -s ' ' '|')

sc_prohibit_AC_LIBOBJ_in_m4:
	@url=https://lists.gnu.org/r/bug-gnulib/2011-06/msg00051.html; \
	if test -d .git; then						\
	  git ls-files m4						\
	     | grep -Ev '^m4/($(allow_AC_LIBOBJ_or))\.m4$$'		\
	     | xargs grep '^ *AC_LIBOBJ('				\
	    && { printf '%s\n' 'Do not use AC_LIBOBJ in m4/*.m4;'	\
		 "see <$$url>"; exit 1; } || :;				\
	else :; fi

sc_pragma_columns:
	@if test -d .git; then						\
	  git ls-files|grep '\.in\.h$$'					\
	      | xargs grep -l '^@PRAGMA_SYSTEM_HEADER@'			\
	      | xargs grep -L '^@PRAGMA_COLUMNS@'			\
	      | grep .							\
	    && { printf '%s\n'						\
		   'the files listed above use @PRAGMA_SYSTEM_HEADER@'	\
		   'without also using @PRAGMA_COLUMNS@' 1>&2;		\
		 exit 1; } || :;					\
	else :; fi

# Verify that certain (for now, only Jim Meyering and Eric Blake's)
# *.c files are consistently cpp indented.
sc_cpp_indent_check:
	@./gnulib-tool --extract-filelist \
	    $$(cd ./modules; grep -ilrE '(meyering|blake)' .) \
	  | sort -u \
	  | grep '\.c$$' \
	  | grep -vE '/(stdio-(read|write)|getloadavg)\.c$$' \
	  | xargs cppi -c

# Ensure that the list of symbols checked for by the
# sc_prohibit_intprops_without_use rule match those in the actual file.
# Extract the symbols from the .h file and compare with the list of
# symbols extracted from the rule in maint.mk.
sc_check_sym_list:
	@i=lib/intprops.h; \
	diff -u <(perl -lne '/^# *define ([A-Z]\w+)\(/ and print $$1' $$i|fmt) \
	  <(sed -n /^_intprops_name/,/^_intprops_syms_re/p top/maint.mk \
	    |sed '/^_/d;s/^  //;s/	*\\$$//')

# Ensure that the copyright statements in files and in the module descriptions
# are consistent.
sc_check_copyright:
	@./check-copyright

# Regenerate some files that are stored in the repository.
regen: MODULES.html

# MODULES.html is periodically being generated and copied to the web pages at
# :ext:USER@cvs.savannah.gnu.org:/web/gnulib/gnulib/
# where it then appears at <https://www.gnu.org/software/gnulib/MODULES.html>.
MODULES.html: MODULES.html.sh
	./MODULES.html.sh > MODULES.html

# A perl BEGIN block to set Y to the current year number and W to Y-1.
_year_and_prev = BEGIN{@t=localtime(time); $$y=$$t[5]+1900; $$w=$$y-1}

# Run this rule once per year (usually early in January)
# to update all FSF copyright year lists here.
# We exclude the files listed in srclist.txt (maintained elsewhere)
# as well as those in tests/unictype (generated).
# Also exclude any file that includes the "GENERATED AUTOMATICALLY" comment,
# being careful not to exclude code that merely generates the comment.
# Also exclude doc/INSTALL*, since they too are generated.
# Also adjust template-style files that must start with a single
# (the current) year number in some places.
# Also adjust version-etc.c and and gendocs.sh.
update-copyright:
	exempt=$$(mktemp);						\
	grep -v '^#' config/srclist.txt|grep -v '^$$'			\
	  | while read top src dst options; do				\
	      test -f "$$dst" && { echo "$$dst"; continue; };		\
	      test -d "$$dst" || continue;				\
	      echo "$$dst"/$$(basename "$$src");			\
	    done > $$exempt;						\
	git ls-files tests/unictype >> $$exempt;			\
	git ls-files doc/INSTALL* >> $$exempt;				\
	git ls-files | grep -vFf $$exempt				\
	  | xargs grep -L '^/\*.*GENERATED AUTOMATICALLY'		\
	  | UPDATE_COPYRIGHT_MAX_LINE_LENGTH=79				\
	    UPDATE_COPYRIGHT_USE_INTERVALS=1				\
	      xargs build-aux/update-copyright
	perl -pi -e '$(_year_and_prev) s/(copyright.*)\b$$w\b/$$1$$y/i'	\
	  lib/version-etc.c doc/gnulib.texi build-aux/gendocs.sh
	perl -pi -e '$(_year_and_prev) s/ $$w-$$y / $$y /g'		\
	  doc/gendocs_template* build-aux/gendocs.sh
	perl -pi -e							\
          '$(_year_and_prev) s/^(scriptversion=)$$w.*/$$1$$y-01-01.00/i' \
	  build-aux/gendocs.sh

=== debian/changelog ===
gnulib (20200105~a7903da-2) unstable; urgency=high

  * QA upload.
  * Rebuild to make arm64 build successful.
  * debian/upstream/metadata: Set upstream metadata fields:
    Repository, Repository-Browse.
  * debian/patches/backport/0006: Add patch to fix regression
    introduced on 2020-01-04.
  * debian/clscan/clscan: Always break the file list into multiline
    text. This may make lintian happy with long Files: list.
  * debian/clscan/files.yaml: Slightly update copyright information
    for files under pygnulib/.
  * debian/copyright: Regenerated with updated clscan tool.
  * debian/watch: Monitor upstream Git HEAD.

 -- Boyuan Yang <byang@debian.org>  Wed, 15 Jan 2020 00:31:19 -0500

gnulib (20200105~a7903da-1) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 14 Jan 2020 16:31:05 -0500

gnulib (20200105~a7903da-1~exp2) experimental; urgency=medium

  * QA upload.
  * debian/control:
    + demote all dependencies to recommendations so that the gnulib
      package can be used for cross compilation.
    + Mark package gnulib as Multi-Arch: foreign.
  * debian/patches: Add patch to lower the autoconf version
    requirement from 2.63 to 2.62. This circumvents FTBFS of
    libtool 2.4.6 with new gnulib snapshot.
  * debian/clscan/clscan: Update boilerplate texts to use secure
    URI for GPL licenses.

 -- Boyuan Yang <byang@debian.org>  Mon, 13 Jan 2020 23:33:13 -0500

gnulib (20200105~a7903da-1~exp1) experimental; urgency=medium

  * QA upload.
  * New upstream git snapshot.
  * debian/control:
    + Bump Standards-Version to 4.4.1.
    + Bump debhelper compat to v12.
  * debian/patches/03-vasnprintf: Dropped, merged upstream.
  * debian/copyright: Refreshed using debian/clscan tool.
  * debian/git-merge-changelog.lintian-overrides: Add override
  * debian/patches: Add patch to relax gettext version
    requirement down to (>= 0.19.8).
    This patch should be removed once gettext 0.20+ is available
    in Debian.
  * debian/clscan/clscan: Updated to handler boilerplate for
    GPLv3+.
    for false positive of spelling-error-in-readme-debian.
  * debian/rules:
    + Enable full hardening during build.
    + Attempt to enable tests during build time.
      - The gettext module is excluded for now, waiting for gettext 0.20.x
        to enter Debian.
      - Only a small amount of tests are enabled for now.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Jan 2020 14:40:45 -0500

gnulib (20140202+stable-4) unstable; urgency=medium

  * QA upload.
  * Orphan package to match 20180621~6979c25-2 in experimental.
  * Fix compat issue with glibc 2.28 (closes: #915151).

 -- Julien Cristau <jcristau@debian.org>  Sun, 31 Mar 2019 14:36:20 +0200

gnulib (20140202+stable-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Diagnose ERE '()|\1' (CVE-2009-5155) (Closes: #924613)

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 15 Mar 2019 21:08:27 +0100

=== debian/control ===
Source: gnulib
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 bison <!nocheck>,
 debhelper-compat (= 12),
 gettext (>= 0.19.8.1) <!nocheck>,
 gperf <!nocheck>,
 perl,
Build-Depends-Indep:
 texinfo,
Standards-Version: 4.4.1
Homepage: https://www.gnu.org/software/gnulib/
Vcs-Git: https://salsa.debian.org/debian/gnulib.git
Vcs-Browser: https://salsa.debian.org/debian/gnulib

Package: git-merge-changelog
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: git merge driver for GNU ChangeLog files
 ChangeLog files *always* foul up most version control systems in
 their default configuration.
 .
 git-merge-changelog is a tool from gnulib designed to help with this
 for the case of GNU-style ChangeLogs; it can be used with at least
 git, bzr, and hg.

Package: gnulib
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 autoconf,
 automake,
 autopoint,
 bison,
 build-essential,
 gettext (>= 0.19.8.1),
 gperf,
 libtool,
 m4,
 texinfo,
Suggests:
 clisp,
 perl,
 python3:any,
Description: GNU Portability Library
 The GNU portability library is a macro system and C declarations and
 definitions for commonly-used API elements and abstracted system behaviors. It
 can be used to improve portability and other functionality in your programs.

## gnulib 20200127~e313a53

=== doc/Makefile ===
# Makefile for gnulib doc.  -*- coding: utf-8 -*-
# Copyright (C) 2004, 2006-2020 Free Software Foundation, Inc.
#
# Copying and distribution of this file, with or without modification,
# are permitted in any medium without royalty provided the copyright
# notice and this notice are preserved.

doc = gnulib

lang_env = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE=
makeinfo_prog = makeinfo
MAKEINFO = $(lang_env) $(makeinfo_prog)

manual_opts = --no-split --reference-limit=2000
TEXI2HTML = $(MAKEINFO) $(manual_opts) --html

# Needed so that tex finds a recent enough texinfo.tex.
tex_opts = -I ../build-aux

%.info: %.texi
	$(MAKEINFO) $(manual_opts) $<

%.html: %.texi
	$(TEXI2HTML) -o $@ $<

%.dvi: %.texi
	texi2dvi $(tex_opts) $< || { if texi2dvi $(tex_opts) $< 2>/dev/null | grep 'TeX capacity exceeded, sorry \[save size=' > /dev/null; then echo '*** You must increase the save_size in your texmf.cnf file, often located under /etc/texmf/.'; fi; exit 1; }

%.pdf: %.texi
	texi2pdf $(tex_opts) $< || { if texi2pdf $(tex_opts) $< 2>/dev/null | grep 'TeX capacity exceeded, sorry \[save size=' > /dev/null; then echo '*** You must increase the save_size in your texmf.cnf file, often located under /etc/texmf/.'; fi; exit 1; }

all: info html dvi
info: $(doc).info
html: $(doc).html
dvi: $(doc).dvi
pdf: $(doc).pdf

INSTALL_PRELUDE = echo '@firstparagraphindent insert'

OMIT_TRAILING_EMPTY_LINES = /^$$/H; /^$$/d; x; s/\n//p; s/\n*//; x

# INSTALL file with directed ASCII quotation marks.
INSTALL: install.texi
	$(INSTALL_PRELUDE) | cat - $< > tmp.texi
	$(MAKEINFO) --plaintext --no-validate tmp.texi \
	  | sed -e '$(OMIT_TRAILING_EMPTY_LINES)' > $@
	rm -f tmp.texi

# INSTALL file with ISO 646 or ISO 8859 quotation marks.
INSTALL.ISO: INSTALL
	sed -e "s/\`\([^']*\)'/'\1'/g" $< > $@

# INSTALL file with ISO 10646 (Unicode) quotation marks.
INSTALL.UTF-8: INSTALL
	sed -e "s/\`\([^']*\)'/‘\1’/g" $< > $@

GNULIB_TEXI_FILES = $(filter-out maintain.texi make-stds.texi standards.texi,$(wildcard *.texi)) $(wildcard posix-headers/*.texi) $(wildcard posix-functions/*.texi) $(wildcard glibc-headers/*.texi) $(wildcard glibc-functions/*.texi)
NEWEST_GNULIB_TEXI_FILE = $(shell ls -t $(GNULIB_TEXI_FILES) | sed 1q)

# Date of last update. Requires GNU date.
updated-stamp: $(GNULIB_TEXI_FILES)
	date -u -r $(NEWEST_GNULIB_TEXI_FILE) +"@set UPDATED %F %T" > $@

# Dependencies. Search for @include to find them all.
gnulib.info gnulib.html gnulib.dvi gnulib.pdf: $(GNULIB_TEXI_FILES) updated-stamp
standards.info standards.html standards.dvi: standards.texi make-stds.texi fdl.texi

mostlyclean:
	rm -f *.aux *.cn *.cp *.cps *.fn *.ky *.log *.pg *.toc *.tp *.vr *.vrs
	rm -f updated-stamp

clean: mostlyclean
	rm -f *.info *.html *.dvi *.ps *.pdf

=== debian/changelog ===
gnulib (20200127~e313a53-1) unstable; urgency=medium

  * QA upload.
  * debian/patches/backport: Drop backported patches.
  * debian/control: Bump Standards-Version to 4.5.0.
  * debian/copyright: Refreshed.
  * debian/rules: Enable test for regex module.

 -- Boyuan Yang <byang@debian.org>  Tue, 28 Jan 2020 13:14:41 -0500

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  perl,
 Build-Depends-Indep:
  texinfo,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://www.gnu.org/software/gnulib/
 Vcs-Git: https://salsa.debian.org/debian/gnulib.git
 Vcs-Browser: https://salsa.debian.org/debian/gnulib

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,20 @@
 #!/usr/bin/make -f
+# -*- makefile -*-
+#  # Uncomment this to turn on verbose mode.
+# export DH_VERBOSE=1
+#
+# # see FEATURE AREAS in dpkg-buildflags(1)
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+#
+# # see ENVIRONMENT in dpkg-buildflags(1)
+# # package maintainers to append CFLAGS
+# #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+# # package maintainers to append LDFLAGS
+# export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-#EXPORT DH_VERBOSE=1
+
+GNULIB_DESTDIR=$(CURDIR)/debian/gnulib/
+
 
 %:
 	dh ${@}
@@ -12,7 +26,7 @@
 	dh_auto_clean
 
 override_dh_auto_configure-arch:
-	./gnulib-tool --create-testdir --without-tests -S \
+	./gnulib-tool --create-testdir --with-tests -S \
 		--dir=debian/git-merge-changelog.src git-merge-changelog
 	dh_auto_configure --sourcedir debian/git-merge-changelog.src
 
@@ -39,6 +53,7 @@
 	chmod 0755 debian/gnulib/usr/share/gnulib/build-aux/config.guess
 	chmod 0755 debian/gnulib/usr/share/gnulib/build-aux/config.sub
 	chmod 0755 debian/gnulib/usr/share/gnulib/build-aux/gendocs.sh
+	-chmod 0644 debian/gnulib/usr/share/gnulib/config/srclistvars.sh
 	chmod 0644 debian/gnulib/usr/share/gnulib/doc/gendocs_template
 	chmod 0644 debian/gnulib/usr/share/gnulib/m4/fflush.m4
 	chmod 0644 debian/gnulib/usr/share/gnulib/modules/canonicalize-lgpl
@@ -52,7 +67,31 @@
 	# Remove unused files
 	rm -f debian/gnulib/usr/share/gnulib/doc/gnulib.info
 	rm -f debian/gnulib/usr/share/gnulib/doc/gnulib.html
-	rm -f debian/gnulib/usr/share/gnulib/modules/COPYING
 	rm -f debian/gnulib/usr/share/gnulib/*/.cvsignore debian/gnulib/usr/share/gnulib/.cvsignore
 	rm -f debian/gnulib/usr/share/gnulib/*/.gitignore debian/gnulib/usr/share/gnulib/.gitignore
 	rm -f debian/gnulib/usr/share/gnulib/*/.gitattributes debian/gnulib/usr/share/gnulib/.gitattributes
+
+
+# Run tests here.
+override_dh_auto_test-indep:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+# FIXME: Full test could be too time-consuming.
+#        If you have better idea, please fix it.
+#
+#        Test exclusion list:
+#          * gettext: Obsolete; Needs gettext >= 0.20 to work (which is not
+#                     available in Debian yet).
+#                     https://bugs.debian.org/934738
+	( \
+	    GNULIB_MODULE_LIST=$$(./gnulib-tool --list | grep -v gettext | tr '\n' ' ') ; \
+	    printf "Current working dir is: %s\n" "$$(realpath .)" ; \
+	    GNULIB_MODULE_LIST="di-set select times regex" ; \
+	    ./gnulib-tool --test $$GNULIB_MODULE_LIST 2>&1 ; \
+	)
+endif
+
+# Do not run tests for binary targets.
+override_dh_auto_test-arch:
+
+override_dh_missing:
+	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=%cd~%h" \
 https://git.savannah.gnu.org/git/gnulib.git \
  HEAD debian uupdate

## gnulib 20200505~0747bf0

=== debian/changelog ===
gnulib (20200505~0747bf0-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
  * debian/control:
    + Bump debhelper compat to v13.
  * debian/rules: Adopt debhelper compat v13 grammar.
  * debian/patches/0005: Dropped, patch picked by Debian libtool.
  * debian/clscan/clscan: Minor improvement on workflow.
  * debian/copyright: Refresh copyright information.

 -- Boyuan Yang <byang@debian.org>  Wed, 06 May 2020 00:00:24 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
  bison <!nocheck>,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  gettext (>= 0.19.8.1) <!nocheck>,
  gperf <!nocheck>,
  perl,

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # # package maintainers to append CFLAGS
 # #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # # package maintainers to append LDFLAGS
-# export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+# export DEB_LDFLAGS_MAINT_APPEND =
 
 
 GNULIB_DESTDIR=$(CURDIR)/debian/gnulib/
@@ -19,11 +19,10 @@
 %:
 	dh ${@}
 
-override_dh_auto_clean:
+execute_before_dh_auto_clean:
 	$(MAKE) -C doc clean
 	-rm -rf debian/git-merge-changelog.src
 	-rm -f debian/git-merge-changelog.1
-	dh_auto_clean
 
 override_dh_auto_configure-arch:
 	./gnulib-tool --create-testdir --with-tests -S \
@@ -92,6 +91,3 @@
 
 # Do not run tests for binary targets.
 override_dh_auto_test-arch:
-
-override_dh_missing:
-	dh_missing --fail-missing

## gnulib 20210102~ebaa53c

=== doc/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Makefile for gnulib doc.  -*- coding: utf-8 -*-
-# Copyright (C) 2004, 2006-2020 Free Software Foundation, Inc.
+# Copyright (C) 2004, 2006-2021 Free Software Foundation, Inc.
 #
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright

=== debian/changelog ===
gnulib (20210102~ebaa53c-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
  * debian/patches/0004: Dropped, we now use gettext 0.20+.
  * debian/control: Bump gettext version requirement to 0.20+.
  * debian/rules: Do not exclude tests for gettext.

 -- Boyuan Yang <byang@debian.org>  Sat, 02 Jan 2021 15:07:40 -0500

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 Build-Depends:
  bison <!nocheck>,
  debhelper-compat (= 13),
- gettext (>= 0.19.8.1) <!nocheck>,
+ gettext (>= 0.20~) <!nocheck>,
  gperf <!nocheck>,
  perl,
 Build-Depends-Indep:
  texinfo,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.gnu.org/software/gnulib/
 Vcs-Git: https://salsa.debian.org/debian/gnulib.git
 Vcs-Browser: https://salsa.debian.org/debian/gnulib

=== debian/rules ===
--- 
+++ 
@@ -61,8 +61,8 @@
 	chmod 0644 debian/gnulib/usr/share/gnulib/tests/test-base64.c
 	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-closein.sh
 	chmod 0644 debian/gnulib/usr/share/gnulib/tests/test-fflush.c
-	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-posix_spawn1.in.sh
-	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-posix_spawn2.in.sh
+	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-posix_spawn-dup2-stdout.in.sh
+	chmod 0755 debian/gnulib/usr/share/gnulib/tests/test-posix_spawn-dup2-stdin.in.sh
 	# Remove unused files
 	rm -f debian/gnulib/usr/share/gnulib/doc/gnulib.info
 	rm -f debian/gnulib/usr/share/gnulib/doc/gnulib.html
@@ -76,13 +76,8 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 # FIXME: Full test could be too time-consuming.
 #        If you have better idea, please fix it.
-#
-#        Test exclusion list:
-#          * gettext: Obsolete; Needs gettext >= 0.20 to work (which is not
-#                     available in Debian yet).
-#                     https://bugs.debian.org/934738
 	( \
-	    GNULIB_MODULE_LIST=$$(./gnulib-tool --list | grep -v gettext | tr '\n' ' ') ; \
+	    GNULIB_MODULE_LIST=$$(./gnulib-tool --list | tr '\n' ' ') ; \
 	    printf "Current working dir is: %s\n" "$$(realpath .)" ; \
 	    GNULIB_MODULE_LIST="di-set select times regex" ; \
 	    ./gnulib-tool --test $$GNULIB_MODULE_LIST 2>&1 ; \

## gnulib 20210822~d383792

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # GNU Makefile for gnulib central.
-# Copyright (C) 2006, 2009-2020 Free Software Foundation, Inc.
+# Copyright (C) 2006, 2009-2021 Free Software Foundation, Inc.
 #
 # Copying and distribution of this file, with or without modification,
 # in any medium, are permitted without royalty provided the copyright

=== debian/changelog ===
gnulib (20210822~d383792-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
  * Bump Standards-Version to 4.6.0 (no changes needed).

 -- Boyuan Yang <byang@debian.org>  Sat, 28 Aug 2021 17:06:21 -0400

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  perl,
 Build-Depends-Indep:
  texinfo,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://www.gnu.org/software/gnulib/
 Vcs-Git: https://salsa.debian.org/debian/gnulib.git
 Vcs-Browser: https://salsa.debian.org/debian/gnulib
@@ -39,7 +39,7 @@
  autopoint,
  bison,
  build-essential,
- gettext (>= 0.19.8.1),
+ gettext (>= 0.20~),
  gperf,
  libtool,
  m4,

## gnulib 20220606~2849690

=== debian/changelog ===
gnulib (20220606~2849690-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
    + Fix compatibility with Ubuntu 22.04 and OpenSSL 3.0.x.
  * debian/control: Set git-merge-changelog to be Section: vcs.
  * debian/control: Bump Standards-Version to 4.6.1.
  * debian/control: Set Rules-Requires-Root: no.
  * debian/clscan: Fix various bugs.
  * debian/copyright: Refresh copyright information.

 -- Boyuan Yang <byang@debian.org>  Fri, 10 Jun 2022 23:37:59 -0400

=== debian/control ===
--- 
+++ 
@@ -10,12 +10,14 @@
  perl,
 Build-Depends-Indep:
  texinfo,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://www.gnu.org/software/gnulib/
 Vcs-Git: https://salsa.debian.org/debian/gnulib.git
 Vcs-Browser: https://salsa.debian.org/debian/gnulib
+Rules-Requires-Root: no
 
 Package: git-merge-changelog
+Section: vcs
 Architecture: any
 Depends:
  ${misc:Depends},

## gnulib 20220829~828413b

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # GNU Makefile for gnulib central.
-# Copyright (C) 2006, 2009-2021 Free Software Foundation, Inc.
+# Copyright (C) 2006, 2009-2022 Free Software Foundation, Inc.
 #
 # Copying and distribution of this file, with or without modification,
 # in any medium, are permitted without royalty provided the copyright
@@ -142,7 +142,13 @@
 	@./check-copyright
 
 # Regenerate some files that are stored in the repository.
-regen: MODULES.html
+regen: build-aux/bootstrap MODULES.html
+
+# build-aux/bootstrap needs to be regenerated from top/bootstrap*.
+build-aux/bootstrap: top/gen-bootstrap.sed top/bootstrap top/bootstrap-funclib.sh
+	sed -f top/gen-bootstrap.sed < top/bootstrap > build-aux/bootstrap-tmp
+	chmod a+x build-aux/bootstrap-tmp
+	mv build-aux/bootstrap-tmp build-aux/bootstrap
 
 # MODULES.html is periodically being generated and copied to the web pages at
 # :ext:USER@cvs.savannah.gnu.org:/web/gnulib/gnulib/
@@ -173,6 +179,9 @@
 	    done > $$exempt;						\
 	git ls-files tests/unictype >> $$exempt;			\
 	git ls-files doc/INSTALL* >> $$exempt;				\
+	for file in $$(git ls-files); do				\
+	  test ! -h $$file || echo $$file;				\
+	done >> $$exempt;						\
 	git ls-files | grep -vFf $$exempt				\
 	  | xargs grep -L '^/\*.*GENERATED AUTOMATICALLY'		\
 	  | UPDATE_COPYRIGHT_MAX_LINE_LENGTH=79				\

=== debian/changelog ===
gnulib (20220829~828413b-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
  * debian/copyright: Update information.

 -- Boyuan Yang <byang@debian.org>  Tue, 30 Aug 2022 16:08:25 -0400

## gnulib 20230113+stable

=== debian/changelog ===
gnulib (20230113+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot from stable branch stable-202301.

 -- Boyuan Yang <byang@debian.org>  Wed, 18 Jan 2023 19:04:30 -0500

gnulib (20230101+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream stable branch stable-202301.

 -- Boyuan Yang <byang@debian.org>  Wed, 11 Jan 2023 13:01:48 -0500

gnulib (20221120~6ec9bc7-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.

 -- Boyuan Yang <byang@debian.org>  Wed, 23 Nov 2022 17:51:25 -0500

## gnulib 20230127+stable

=== debian/changelog ===
gnulib (20230127+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot from stable branch stable-202301.

 -- Boyuan Yang <byang@debian.org>  Wed, 08 Feb 2023 20:23:31 -0500

## gnulib 20230209+stable

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # GNU Makefile for gnulib central.
-# Copyright (C) 2006, 2009-2022 Free Software Foundation, Inc.
+# Copyright (C) 2006, 2009-2023 Free Software Foundation, Inc.
 #
 # Copying and distribution of this file, with or without modification,
 # in any medium, are permitted without royalty provided the copyright

=== debian/changelog ===
gnulib (20230209+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot from stable branch stable-202301.

 -- Boyuan Yang <byang@debian.org>  Fri, 24 Feb 2023 15:36:19 -0500

## gnulib 20230615+stable

=== Makefile ===
--- 
+++ 
@@ -65,7 +65,7 @@
 sc_maint:
 	@rm -f maint.mk; ln -s top/maint.mk maint.mk
 	$(MAKE) -s srcdir=. gnulib_dir=. _build-aux=build-aux \
-            -f cfg.mk -f maint.mk syntax-check
+	        -f cfg.mk -f maint.mk syntax-check
 	rm -f maint.mk
 
 # Files in m4/ that (exceptionally) may use AC_LIBOBJ.
@@ -192,5 +192,5 @@
 	perl -pi -e '$(_year_and_prev) s/ $$w-$$y / $$y /g'		\
 	  doc/gendocs_template* build-aux/gendocs.sh
 	perl -pi -e							\
-          '$(_year_and_prev) s/^(scriptversion=)$$w.*/$$1$$y-01-01.00/i' \
+	  '$(_year_and_prev) s/^(scriptversion=)$$w.*/$$1$$y-01-01.00/i' \
 	  build-aux/gendocs.sh

=== debian/changelog ===
gnulib (20230615+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot from stable branch stable-202301.

 -- Boyuan Yang <byang@debian.org>  Tue, 20 Jun 2023 14:58:32 -0400

## gnulib 20230718+stable

=== debian/changelog ===
gnulib (20230718+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot from stable branch stable-202307.

 -- Boyuan Yang <byang@debian.org>  Fri, 21 Jul 2023 19:27:51 -0400

## gnulib 20231002+stable

=== debian/changelog ===
gnulib (20231002+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot from stable branch stable-202307.

 -- Boyuan Yang <byang@debian.org>  Fri, 06 Oct 2023 19:24:56 -0400

## gnulib 20240117+stable

=== debian/changelog ===
gnulib (20240117+stable-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot from stable branch stable-202401.

 -- Boyuan Yang <byang@debian.org>  Thu, 18 Jan 2024 19:55:03 -0500

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  perl,
 Build-Depends-Indep:
  texinfo,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://www.gnu.org/software/gnulib/
 Vcs-Git: https://salsa.debian.org/debian/gnulib.git
 Vcs-Browser: https://salsa.debian.org/debian/gnulib

## gnulib 20240412~dfb7117+stable202401.20240408~aa0aa87

=== debian/changelog ===
gnulib (20240412~dfb7117+stable202401.20240408~aa0aa87-3ubuntu1) oracular; urgency=medium

  * debian/tests/control:
    Add allow-stderr to Restrictions. Git 2.45 is emitting a message about
    the default branch name to stderr. This fixes the autopkgtest.
    (LP: #2069304)

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Thu, 13 Jun 2024 14:54:21 +0100

gnulib (20240412~dfb7117+stable202401.20240408~aa0aa87-3) unstable; urgency=medium

  * Add dh_gnulib_patch and rework dh integration.  Closes: #1069597.

 -- Simon Josefsson <simon@josefsson.org>  Fri, 10 May 2024 20:45:07 +0200

gnulib (20240412~dfb7117+stable202401.20240408~aa0aa87-2) unstable; urgency=medium

  * Upload to unstable.
  * Add gnulibvars.mk, for use in debian/rules.
  * Add Vcs-Git branch.
  * Lintian fixes.
  * metadata: Add Bug-Submit and Documentation links.
  * Fix gnulib-tool --version.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 17 Apr 2024 17:11:14 +0200

gnulib (20240412~dfb7117+stable202401.20240408~aa0aa87-1) experimental; urgency=medium

  * Adopt package.  Closes: #921954.
  * New upstream snapshot.
  * Add debian/README.source.
  * gbp.conf: Set branches.
  * Ship gnulib.bundle, Python gnulib-tool, DEPENDENCIES, HACKING.
  * Bump Standards-Version: 4.7.0.
  * Bump debian/* copyright years.
  * gnulib: Add Suggests: git.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 07 Apr 2024 10:08:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,10 @@
 Source: gnulib
 Section: devel
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Simon Josefsson <simon@josefsson.org>
+Uploaders:
+ Boyuan Yang <byang@debian.org>,
 Build-Depends:
  bison <!nocheck>,
  debhelper-compat (= 13),
@@ -10,9 +13,9 @@
  perl,
 Build-Depends-Indep:
  texinfo,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://www.gnu.org/software/gnulib/
-Vcs-Git: https://salsa.debian.org/debian/gnulib.git
+Vcs-Git: https://salsa.debian.org/debian/gnulib.git -b debian/sid
 Vcs-Browser: https://salsa.debian.org/debian/gnulib
 Rules-Requires-Root: no
 
@@ -48,6 +51,7 @@
  texinfo,
 Suggests:
  clisp,
+ git,
  perl,
  python3:any,
 Description: GNU Portability Library

=== debian/tests/control ===
Tests: test-dh-gnulib-patch
Depends:
 git,
 gnulib,
Restrictions: allow-stderr

## gnulib 20240701

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # GNU Makefile for gnulib central.
-# Copyright (C) 2006, 2009-2023 Free Software Foundation, Inc.
+# Copyright (C) 2006, 2009-2024 Free Software Foundation, Inc.
 #
 # Copying and distribution of this file, with or without modification,
 # in any medium, are permitted without royalty provided the copyright
@@ -80,10 +80,12 @@
   fcntl			\
   fprintf-posix		\
   open			\
-  printf-posix-rpl	\
+  printf-posix		\
   snprintf		\
   sprintf-posix		\
   stdio_h		\
+  termcap		\
+  terminfo		\
   vasnprintf		\
   vasprintf		\
   vdprintf		\
@@ -136,6 +138,109 @@
 	  <(sed -n /^_intprops_name/,/^_intprops_syms_re/p top/maint.mk \
 	    |sed '/^_/d;s/^  //;s/	*\\$$//')
 
+
+# List of C macros defined through AH_VERBATIM in m4/extern-inline.m4:
+config_h_MACROS1 = \
+  _GL_INLINE \
+  _GL_EXTERN_INLINE \
+  _GL_INLINE_HEADER_BEGIN \
+  _GL_INLINE_HEADER_END
+# List of C macros defined through AH_VERBATIM in m4/gnulib-common.m4:
+config_h_MACROS2 = \
+  _GL_GNUC_PREREQ \
+  _Noreturn \
+  _GL_ATTRIBUTE_ALLOC_SIZE \
+  _GL_ATTRIBUTE_ALWAYS_INLINE \
+  _GL_ATTRIBUTE_ARTIFICIAL \
+  _GL_ATTRIBUTE_COLD \
+  _GL_ATTRIBUTE_CONST \
+  _GL_ATTRIBUTE_DEALLOC \
+  _GL_ATTRIBUTE_DEPRECATED \
+  _GL_ATTRIBUTE_ERROR \
+  _GL_ATTRIBUTE_WARNING \
+  _GL_ATTRIBUTE_EXTERNALLY_VISIBLE \
+  _GL_ATTRIBUTE_FALLTHROUGH \
+  _GL_ATTRIBUTE_FORMAT \
+  _GL_ATTRIBUTE_LEAF \
+  _GL_ATTRIBUTE_MALLOC \
+  _GL_ATTRIBUTE_MAY_ALIAS \
+  _GL_ATTRIBUTE_MAYBE_UNUSED \
+  _GL_UNUSED \
+  _GL_ATTRIBUTE_NODISCARD \
+  _GL_ATTRIBUTE_NOINLINE \
+  _GL_ATTRIBUTE_NONNULL \
+  _GL_ATTRIBUTE_NONSTRING \
+  _GL_ATTRIBUTE_NOTHROW \
+  _GL_ATTRIBUTE_PACKED \
+  _GL_ATTRIBUTE_PURE \
+  _GL_ATTRIBUTE_RETURNS_NONNULL \
+  _GL_ATTRIBUTE_SENTINEL \
+  _GL_ATTRIBUTE_UNUSED \
+  _GL_UNUSED_LABEL \
+  _GL_BEGIN_C_LINKAGE \
+  _GL_END_C_LINKAGE \
+  _GL_ASYNC_SAFE \
+  _GL_CMP
+# List of C macros defined through AH_VERBATIM in m4/nullptr.m4:
+config_h_MACROS3 = \
+  nullptr
+# List of C macros defined through AH_VERBATIM in m4/posixcheck.m4:
+config_h_MACROS4 = \
+  GNULIB_POSIXCHECK
+# List of C macros defined through AH_VERBATIM in m4/sh-filename.m4:
+config_h_MACROS5 = \
+  BOURNE_SHELL
+# List of C macros defined through AH_VERBATIM in m4/stdalign.m4:
+config_h_MACROS6 = \
+  alignof \
+  alignas
+# List of C macros defined through AH_VERBATIM in m4/stdarg.m4:
+config_h_MACROS7 = \
+  va_copy
+# List of C macros defined through AH_VERBATIM in m4/threads_h.m4:
+config_h_MACROS8 = \
+  _Thread_local
+# List of C macros defined through AH_VERBATIM (only the most important ones):
+config_h_MACROS = \
+  $(config_h_MACROS1) $(config_h_MACROS2) $(config_h_MACROS3) \
+  $(config_h_MACROS4) $(config_h_MACROS5) $(config_h_MACROS6) \
+  $(config_h_MACROS7) $(config_h_MACROS8)
+
+# Ensure that .h files that use macros from config.h contain a reminder to
+# include <config.h>.
+sc_check_config_h_reminder:
+	fail=0; \
+	for file in `grep -l -F -w -f <(for macro in $(config_h_MACROS); do echo $$macro; done) lib/*.h lib/*/*.h`; do \
+	  : "Filter out .h files that are not public header files of their respective module."; \
+	  include_pattern='[<"]'`echo $$file | sed -e 's,^lib/,,' -e 's,[.]in[.]h,.h,' -e 's,_,[/_],g' -e 's,[.],[.],g'`'[>"]' ; \
+	  if ./gnulib-tool --extract-include-directive `./gnulib-tool --find $$file` | grep "$$include_pattern" >/dev/null; then \
+	    grep '# *error "Please include config[.]h first[.]"' $$file >/dev/null \
+	      || { echo -n "File $$file lacks a config.h reminder. Needed for:"; \
+	           for macro in $(config_h_MACROS); do \
+	             if grep -F -w $$macro $$file >/dev/null; then echo -n " $$macro"; fi; \
+	           done; \
+	           if grep -F HAVE_RAW_DECL_ $$file >/dev/null; then echo -n " HAVE_RAW_DECL_*"; fi; \
+	           echo; \
+	           fail=1; \
+	         }; \
+	  fi; \
+	done; \
+	exit $$fail
+
+
+# Ensure that .h files that invoke _GL_INLINE_HEADER_BEGIN also invoke
+# _GL_INLINE_HEADER_END.  Otherwise, some GCC diagnostics remain turned off
+# for the rest of the compilation unit.
+sc_check_GL_INLINE_HEADER_use:
+	fail=0; \
+	for file in `grep -l -F -w _GL_INLINE_HEADER_BEGIN lib/*.h lib/*/*.h`; do \
+	  grep -l -F -w _GL_INLINE_HEADER_END $$file >/dev/null \
+	    || { echo "File $$file lacks an invocation of _GL_INLINE_HEADER_END."; \
+	         fail=1; \
+	       }; \
+	done; \
+	exit $$fail
+
 # Ensure that the copyright statements in files and in the module descriptions
 # are consistent.
 sc_check_copyright:
@@ -158,6 +263,9 @@
 
 # A perl BEGIN block to set Y to the current year number and W to Y-1.
 _year_and_prev = BEGIN{@t=localtime(time); $$y=$$t[5]+1900; $$w=$$y-1}
+
+# Which TZ setting to use when updating copyright.
+COPYRIGHT_TZ = UTC0
 
 # Run this rule once per year (usually early in January)
 # to update all FSF copyright year lists here.
@@ -168,8 +276,9 @@
 # Also exclude doc/INSTALL*, since they too are generated.
 # Also adjust template-style files that must start with a single
 # (the current) year number in some places.
-# Also adjust version-etc.c and and gendocs.sh.
+# Also adjust version-etc.c and gendocs.sh.
 update-copyright:
+	export TZ='$(COPYRIGHT_TZ)';					\
 	exempt=$$(mktemp);						\
 	grep -v '^#' config/srclist.txt|grep -v '^$$'			\
 	  | while read top src dst options; do				\
@@ -177,7 +286,6 @@
 	      test -d "$$dst" || continue;				\
 	      echo "$$dst"/$$(basename "$$src");			\
 	    done > $$exempt;						\
-	git ls-files tests/unictype >> $$exempt;			\
 	git ls-files doc/INSTALL* >> $$exempt;				\
 	for file in $$(git ls-files); do				\
 	  test ! -h $$file || echo $$file;				\
@@ -187,10 +295,13 @@
 	  | UPDATE_COPYRIGHT_MAX_LINE_LENGTH=79				\
 	    UPDATE_COPYRIGHT_USE_INTERVALS=1				\
 	      xargs build-aux/update-copyright
+	export TZ='$(COPYRIGHT_TZ)';					\
 	perl -pi -e '$(_year_and_prev) s/(copyright.*)\b$$w\b/$$1$$y/i'	\
 	  lib/version-etc.c doc/gnulib.texi build-aux/gendocs.sh
+	export TZ='$(COPYRIGHT_TZ)';					\
 	perl -pi -e '$(_year_and_prev) s/ $$w-$$y / $$y /g'		\
 	  doc/gendocs_template* build-aux/gendocs.sh
+	export TZ='$(COPYRIGHT_TZ)';					\
 	perl -pi -e							\
 	  '$(_year_and_prev) s/^(scriptversion=)$$w.*/$$1$$y-01-01.00/i' \
 	  build-aux/gendocs.sh

=== doc/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Makefile for gnulib doc.  -*- coding: utf-8 -*-
-# Copyright (C) 2004, 2006-2021 Free Software Foundation, Inc.
+# Copyright (C) 2004, 2006-2024 Free Software Foundation, Inc.
 #
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright
@@ -9,7 +9,11 @@
 
 lang_env = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE=
 makeinfo_prog = makeinfo
-MAKEINFO = $(lang_env) $(makeinfo_prog)
+# ASCII_DASHES_AND_QUOTES=0 is needed for makeinfo versions ≥ 7.1.
+# CHECK_NORMAL_MENU_STRUCTURE=1 is needed for makeinfo versions ≥ 6.8.
+MAKEINFO = $(lang_env) $(makeinfo_prog) \
+ -c ASCII_DASHES_AND_QUOTES=0 \
+ -c CHECK_NORMAL_MENU_STRUCTURE=1
 
 manual_opts = --no-split --reference-limit=2000
 TEXI2HTML = $(MAKEINFO) $(manual_opts) --html
@@ -39,20 +43,28 @@
 
 OMIT_TRAILING_EMPTY_LINES = /^$$/H; /^$$/d; x; s/\n//p; s/\n*//; x
 
-# INSTALL file with directed ASCII quotation marks.
+# INSTALL file with UTF-8 encoding.
 INSTALL: install.texi
 	$(INSTALL_PRELUDE) | cat - $< > tmp.texi
 	$(MAKEINFO) --plaintext --no-validate tmp.texi \
 	  | sed -e '$(OMIT_TRAILING_EMPTY_LINES)' > $@
 	rm -f tmp.texi
 
-# INSTALL file with ISO 646 or ISO 8859 quotation marks.
+# INSTALL file with ASCII encoding.
 INSTALL.ISO: INSTALL
-	sed -e "s/\`\([^']*\)'/'\1'/g" $< > $@
+	sed \
+          -e 's/©/(C)/g' \
+          -e 's/–/-/g' \
+          -e 's/‘/'\''/g' \
+          -e 's/’/'\''/g' \
+          -e 's/“/"/g' \
+          -e 's/”/"/g' \
+          $< > $@
 
-# INSTALL file with ISO 10646 (Unicode) quotation marks.
+# INSTALL file with UTF-8 encoding.
+# This file is obsolescent, as INSTALL now uses UTF-8.
 INSTALL.UTF-8: INSTALL
-	sed -e "s/\`\([^']*\)'/‘\1’/g" $< > $@
+	cp $< $@
 
 GNULIB_TEXI_FILES = $(filter-out maintain.texi make-stds.texi standards.texi,$(wildcard *.texi)) $(wildcard posix-headers/*.texi) $(wildcard posix-functions/*.texi) $(wildcard glibc-headers/*.texi) $(wildcard glibc-functions/*.texi)
 NEWEST_GNULIB_TEXI_FILE = $(shell ls -t $(GNULIB_TEXI_FILES) | sed 1q)

=== debian/changelog ===
gnulib (20240701-1) unstable; urgency=medium

  * New upstream (branch stable-202407 master
    2520437549b14f3785b4b3c32a0a3fc792d4a9c0).
  * tests: Handle new git stderr warning, reported by Danilo Gondolfo.
  * patches/02-shebang.patch: Add Forwarded: URL.
  * patches/03-tests.patch: Drop unnecessary (?) patch.
  * Improve README.source.
  * test-dh-gnulib-patch, patches/00-gnulib-tool-version: Fuzz patches.
  * Include .gnulib-tool.py for python-based gnulib-tool.
  * Shorten version number.  Closes: #1069268.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 02 Jul 2024 19:38:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gnulib
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Simon Josefsson <simon@josefsson.org>
+Maintainer: Simon Josefsson <simon@josefsson.org>
 Uploaders:
  Boyuan Yang <byang@debian.org>,
 Build-Depends:

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 # # package maintainers to append LDFLAGS
 # export DEB_LDFLAGS_MAINT_APPEND =
 
+include /usr/share/dpkg/pkg-info.mk
 
 GNULIB_DESTDIR=$(CURDIR)/debian/gnulib/
 
@@ -35,7 +36,7 @@
 
 override_dh_auto_build-arch:
 	dh_auto_build --sourcedir debian/git-merge-changelog.src
-	pod2man --section=1 debian/git-merge-changelog.pod debian/git-merge-changelog.1
+	pod2man --section=1 --center "Gnulib" --release $(DEB_VERSION) debian/git-merge-changelog.pod debian/git-merge-changelog.1
 
 override_dh_auto_install-arch:
 	dh_auto_install --sourcedir=debian/git-merge-changelog.src --destdir=debian/git-merge-changelog
@@ -43,9 +44,15 @@
 override_dh_auto_install-indep:
 	mkdir -p debian/gnulib/usr/bin
 	cp -a check-module debian/gnulib/usr/bin
-	mkdir -p debian/gnulib/usr/share/gnulib
+	cp -v debian/local/dh_gnulib_patch debian/gnulib/usr/bin/
+	mkdir -p debian/gnulib/usr/share/gnulib/debian/patches.d/00-gnulib-tool-version/
+	cp -v debian/local/gnulib-dpkg.mk debian/gnulib/usr/share/gnulib/debian/
+	cp -v debian/patches/00*-gnulib-tool-version.patch debian/gnulib/usr/share/gnulib/debian/patches.d/00-gnulib-tool-version/
+	mkdir -p debian/gnulib/usr/share/man/man1
+	pod2man --section=1 --center "Gnulib" --release $(DEB_VERSION) debian/local/dh_gnulib_patch.pod debian/gnulib/usr/share/man/man1/dh_gnulib_patch.1
 	cp -a build-aux posix-modules config doc lib m4 modules top tests \
-	      MODULES.html.sh Makefile gnulib-tool cfg.mk check-copyright \
+	      MODULES.html.sh Makefile cfg.mk check-copyright \
+	      gnulib-tool* .gnulib-tool.py pygnulib gnulib.bundle \
 	      debian/gnulib/usr/share/gnulib
 	ln -s ../share/gnulib/gnulib-tool debian/gnulib/usr/bin
 	# Fix permissions
@@ -69,7 +76,8 @@
 	rm -f debian/gnulib/usr/share/gnulib/*/.cvsignore debian/gnulib/usr/share/gnulib/.cvsignore
 	rm -f debian/gnulib/usr/share/gnulib/*/.gitignore debian/gnulib/usr/share/gnulib/.gitignore
 	rm -f debian/gnulib/usr/share/gnulib/*/.gitattributes debian/gnulib/usr/share/gnulib/.gitattributes
-
+	# Show differences between source gnulib and /usr/share/gnulib
+	-env LANG=C diff -ur . debian/gnulib/usr/share/gnulib | grep -e '^diff' -e '^Only in' | grep -v '^Only in ./debian'
 
 # Run tests here.
 override_dh_auto_test-indep:

=== debian/tests/control ===
Tests: test-dh-gnulib-patch
Depends:
 git,
 gnulib,
